--- ZODB/Connection.py~	2003-11-28 17:44:49.000000000 +0100
+++ ZODB/Connection.py	2003-12-08 21:26:49.000000000 +0100
@@ -158,8 +158,6 @@
         Any objects modified since the last transaction are invalidated.
         """
         self._db = odb
-        self._reader = ConnectionObjectReader(self, self._cache,
-                                              self._db._classFactory)
         self._storage = odb._storage
         self._sortKey = odb._storage.sortKey
         self.new_oid = odb._storage.new_oid
@@ -168,6 +166,8 @@
             self._resetCache()
         else:
             self._flush_invalidations()
+        self._reader = ConnectionObjectReader(self, self._cache,
+                                              self._db._classFactory)
         self._opened = time()
 
         return self