--- Zope/Startup/__init__.py~	2005-04-05 07:47:31.000000000 +0200
+++ Zope/Startup/__init__.py	2005-07-26 19:21:15.000000000 +0200
@@ -70,6 +70,10 @@
                  'Shutting down with exit code %s' % ZServer.exit_code)
         sys.exit(ZServer.exit_code)
     finally:
+        # DM 2005-07-26: close the DB to let (e.g.) "FileStorage"s
+        #  cleanup correctly
+        from Globals import DB
+        if DB is not None: DB.close()
         starter.unlinkLockFile()
         starter.unlinkPidFile()
         started = False