--- lib/python/AccessControl/:cAccessControl.c	Wed Jul 11 22:49:13 2001
+++ lib/python/AccessControl/cAccessControl.c	Sun Sep  9 17:22:52 2001
@@ -1524,6 +1524,7 @@
 		Py_DECREF(r);
 		r = self->__roles__;
 		if (r == NULL) goto err;
+		Py_INCREF(r);
 	}
 
 	/*|