--- Zope/App/startup.py~	2003-02-28 16:59:25.000000000 +0100
+++ Zope/App/startup.py	2003-03-17 11:13:28.000000000 +0100
@@ -140,9 +140,9 @@
                 global conflict_errors
                 conflict_errors = conflict_errors + 1
                 method_name = REQUEST.get('PATH_INFO', '')
-                err = ('ZODB conflict error at %s '
+                err = ('ZODB conflict error at %s: %s'
                        '(%s conflicts since startup at %s)')
-                LOG(err % (method_name, conflict_errors, startup_time),
+                LOG(err % (method_name, str(v), conflict_errors, startup_time),
                     INFO, '')
                 LOG('Conflict traceback', BLATHER, '', error=sys.exc_info())
                 raise ZPublisher.Retry(t, v, traceback)