--- lib/python/DateTime/:DateTime.py	Tue Mar 14 18:04:59 2000
+++ lib/python/DateTime/DateTime.py	Sun May 28 18:43:28 2000
@@ -94,6 +94,8 @@
 from types import InstanceType,IntType,FloatType,StringType
 try: from time import tzname
 except: tzname=('UNKNOWN','UNKNOWN')
+try: from time import daylight; tzname_index= daylight; del daylight
+except: tzname_index= 0
 
 
 
@@ -687,7 +689,7 @@
                   'saturday': 7,  'sat': 7}
 
 
-    try: _localzone=_cache._zmap[lower(tzname[0])]
+    try: _localzone=_cache._zmap[lower(tzname[tzname_index])]
     except:
         try:
             t=time()