--- DTMLDebug.py~	Thu Jul 26 23:46:59 2001
+++ DTMLDebug.py	Sat Jul 28 12:09:32 2001
@@ -170,10 +170,10 @@
             call_stack = None
         # Output the collected information.
         if exc_info is not None:
             exc_type = exc_info[0]
             exc_type = str(getattr(exc_type, '__name__', exc_type))
-            raise exc_info[0], dtmlexc(None, None, lookup_name=name,
+            try:
+              raise exc_info[0], dtmlexc(None, None, lookup_name=name,
                                        lookup_stack=lookup_stack,
                                        method_url=method_url,
                                        method_name=method_name,
@@ -184,6 +184,8 @@
                                        exc_value=str(exc_info[1]),
                                        exc_tb=exc_info[2],
                                        ), exc_info[2]
+            except exc_info[0]: raise
+            except: raise exc_info[0], exc_info[1], exc_info[2]
         else:
             return dtmlexc(None, None, lookup_name=name,
                            lookup_stack=lookup_stack,