--- :::FileStorage.py	2003-04-14 15:08:30.000000000 +0200
+++ FileStorage.py	2003-06-03 23:28:08.000000000 +0200
@@ -572,7 +572,13 @@
                 current_oids[oid] = 1
                 # Once we've found the data we are looking for,
                 # we can stop chasing backpointers.
-                break
+
+                # DM: the following "break" broke version commit
+                #     because it effectively restricted the version
+                #     to a single object
+                #     We are *NOT* chasing backpointers here
+                #     but "oids" belonging to the version
+                # break
 
             else:
                 # Hm.  This is a non-current record.  Is there a