Index: fsdump.py
===================================================================
RCS file: /data1/cvsep/FremdProdukte/Zope/lib/python/ZODB/fsdump.py,v
retrieving revision 1.1.1.4
retrieving revision 1.5
diff -u -u -r1.1.1.4 -r1.5
--- fsdump.py	16 Sep 2003 07:54:43 -0000	1.1.1.4
+++ fsdump.py	16 Sep 2003 10:22:59 -0000	1.5
@@ -49,9 +49,9 @@
         classname = ''
     return modname, classname
 
-def fsdump(path, file=None, with_offset=1):
+def fsdump(path, file=None, with_offset=1, start= None, stop=None):
     i = 0
-    iter = FileIterator(path)
+    iter = FileIterator(path,start,stop)
     for trans in iter:
         if with_offset:
             print >> file, "Trans #%05d tid=%016x time=%s offset=%d" % \
@@ -83,8 +83,8 @@
                 bp = "bp=%016x" % U64(rec.data_txn)
             else:
                 bp = ""
-            print >> file, "  data #%05d oid=%016x %sclass=%s %s" % \
-                  (j, U64(rec.oid), version, fullclass, bp)
+            print >> file, "  data #%05d oid=%016x %sclass=%s %s size=%d" % \
+                  (j, U64(rec.oid), version, fullclass, bp, rec.data and len(rec.data) or 0)
             j += 1
         print >> file
         i += 1
Index: FileStorage.py
===================================================================
RCS file: /data1/cvsep/FremdProdukte/Zope/lib/python/ZODB/FileStorage.py,v
retrieving revision 1.1.1.6
retrieving revision 1.8
diff -u -u -r1.1.1.6 -r1.8
--- FileStorage.py	16 Sep 2003 07:54:43 -0000	1.1.1.6
+++ FileStorage.py	16 Sep 2003 10:22:59 -0000	1.8
@@ -2279,6 +2279,7 @@
         d = {'id': base64.encodestring(tid).rstrip(),
              'time': TimeStamp(tid).timeTime(),
              'user_name': u,
+             'size' : U64(tl),
              'description': d}
         d.update(e)
         return d